# Evaluator codes. These codes are the only ones recognized by the
# run-time expression evaluator, during the evaluation of the RPN
# code generated by the parser.

# End of code marker
define	PEV_EOC		(-1)

# Numbers
define	PEV_NUMBER	0		# real constant

# Variables
define	PEV_OBSVAR	1		# observational variable
define	PEV_CATVAR	2		# catalog variable
define	PEV_PARAM	3		# fitting or constant parameter
define	PEV_SETEQ	4		# set equation
define	PEV_EXTEQ	5		# extinction equation
define	PEV_TRNEQ	6		# transformation equation

# Unary operators
define	PEV_UPLUS	10		# unary plus
define	PEV_UMINUS	11		# unary minus

# Binary operators
define	PEV_PLUS	20		# addition
define	PEV_MINUS	21		# substraction
define	PEV_STAR	22		# multiplication
define	PEV_SLASH	23		# division
define	PEV_EXPON	24		# exponentiation

# Functions
define	PEV_ABS		30		# absolute value
define	PEV_ACOS	31		# arc cosine
define	PEV_ASIN	32		# arc sine
define	PEV_ATAN	33		# arc tangent
define	PEV_COS		34		# cosine
define	PEV_EXP		35		# exponential
define	PEV_LOG		36		# natural logarithm
define	PEV_LOG10	37		# decimal logarithm
define	PEV_SIN		38		# sine
define	PEV_SQRT	39		# square root
define	PEV_TAN		40		# tangent
